"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Headers = (function () {
    function Headers() {
        this.data = {};
    }
    Headers.prototype.append = function (name, value) {
        this.data[name] = value;
    };
    Headers.prototype.delete = function (name) {
        delete this.data[name];
    };
    Headers.prototype.get = function (name) {
        return this.data[name] || null;
    };
    Headers.prototype.has = function (name) {
        return typeof this.data[name] !== 'undefined';
    };
    Headers.prototype.set = function (name, value) {
        this.data[name] = value;
    };
    Headers.prototype.forEach = function (callbackfn, thisArg) {
        for (var key in this.data) {
            callbackfn.call(thisArg, this.data[key], key, this);
        }
    };
    return Headers;
}());
exports.default = Headers;
