"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var client_1 = require("./client");
function inject(fetch, FormData, ua) {
    function setUA(client) {
        if (!client._options.init) {
            client._options.init = {};
        }
        var init = client._options.init;
        if (!init.headers) {
            init.headers = {};
        }
        if (!init.headers['User-Agent']) {
            init.headers['User-Agent'] = ua;
        }
    }
    function setOptions(options) {
        this._setOptions(options);
        if (ua) {
            setUA(this);
        }
    }
    client_1.default._setOptions = client_1.default.setOptions;
    client_1.default.setOptions = setOptions;
    client_1.default.setOptions({ fetch: fetch, FormData: FormData });
    var create = client_1.default.create;
    var resolve = client_1.default.resolve;
    function newCreate(options) {
        options = options || {};
        if (!options.fetch) {
            options.fetch = fetch;
        }
        if (!options.FormData) {
            options.FormData = FormData;
        }
        var client = create(options);
        client.create = newCreate;
        client.resolve = newResolve;
        if (ua) {
            client._setOptions = client.setOptions;
            client.setOptions = setOptions;
            setUA(client);
        }
        return client;
    }
    function newResolve(key) {
        var client = resolve(key);
        if (!client._count) {
            if (!client._options.fetch) {
                client.setOptions({ fetch: fetch });
            }
            if (!client._options.FormData) {
                client.setOptions({ FormData: FormData });
            }
        }
        client.create = newCreate;
        client.resolve = newResolve;
        if (ua) {
            client._setOptions = client.setOptions;
            client.setOptions = setOptions;
            setUA(client);
        }
        return client;
    }
    client_1.default.create = newCreate;
    client_1.default.resolve = newResolve;
    return client_1.default;
}
exports.default = inject;
